#ifndef HIERARCHYITEM_H
#define HIERARCHYITEM_H

#include "parsec_mac_qt5_global.h"

#include <QList>

class PARSEC_MAC_QT5_EXPORT HierarchyItem
{
public:

    static HierarchyItem * createItem( HierarchyItem */*parent*/ = nullptr );

    HierarchyItem( HierarchyItem * /*parent*/ = nullptr );
    virtual ~HierarchyItem();
    HierarchyItem * parent() const;
    void setParent( HierarchyItem * /*parent*/ );
    bool isRoot() const;
    bool isLeaf() const;
    int childCount() const;
    QList< HierarchyItem * > & childrens();
    const QList< HierarchyItem * > & childrens() const;
    QList< HierarchyItem * > childrensAll() const;

protected:

    HierarchyItem *parentItem;
    QList< HierarchyItem * > childItems;
};

#endif
