#ifndef HIERARCHYMODEL_H
#define HIERARCHYMODEL_H

#include <QAbstractItemModel>

#include "hierarchyitem.h"

class PARSEC_MAC_QT5_EXPORT HierarchyModel : public QAbstractItemModel
{

Q_OBJECT

signals:

public:

    HierarchyModel( QObject * /*parent*/ = nullptr
                  , HierarchyItem * ( * /*createItemFunction*/ )( HierarchyItem * ) =  HierarchyItem::createItem );
    virtual ~HierarchyModel() override;
    QModelIndex index( int /*row*/
                     , int /*column*/
                     , const QModelIndex & /*parent*/ = QModelIndex() ) const override;
    QModelIndex parent( const QModelIndex & /*index*/ ) const override;
    int rowCount( const QModelIndex & /*index*/ = QModelIndex() ) const override;

public slots:

protected:

    QModelIndex itemToIndex( HierarchyItem * /*item*/ ) const;
    HierarchyItem * indexToItem( const QModelIndex & /*index*/ ) const;

    HierarchyItem * ( *createItem )( HierarchyItem * );
    HierarchyItem *rootItem;
};

#endif // HIERARCHYMODEL_H
