#ifndef MICLEVELCOMBOBOX_H
#define MICLEVELCOMBOBOX_H

#include "parsec_mac_qt5_global.h"

#include <QComboBox>

#include <parsec/pdp.h>

namespace ParsecQt5
{

class PARSEC_MAC_QT5_EXPORT ILevelComboBox : public QComboBox
{
    Q_OBJECT

signals:

    void valueChanged( PDP_ILEV_T );

public:

    ILevelComboBox( QWidget * /*parent*/ = nullptr);
    ILevelComboBox( uid_t /*uid*/, QWidget * /*parent*/ = nullptr );
    virtual ~ILevelComboBox();

    bool isSuitable() const;
    PDP_ILEV_T minimumValue() const;
    PDP_ILEV_T maximumValue() const;
    PDP_ILEV_T value() const;

    bool rebuild();
    bool isRebuilt() const;

public slots:

    bool setUid( uid_t uid );
    bool setMinimumValue( PDP_ILEV_T );
    bool setMaximumValue( PDP_ILEV_T );
    bool setValue( PDP_ILEV_T /*iLev*/, bool /*force*/ = false );

private slots:

    void activated( int );

private:

    bool setValuePrivate( PDP_ILEV_T /*iLev*/, bool /*force*/ = false );

    PDP_ILEV_T _minimumValue { 0 };
    PDP_ILEV_T _maximumValue { 0 };
    uid_t _uid { 0 };

    bool _isUid;
    bool _isMinimumValue;
    bool _isMaximumValue;
    bool _isRebuilt { false };



public slots:

};

}

#endif // MICLEVELCOMBOBOX_H
