/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef LOGINMACLABELDIALOG_H
#define LOGINMACLABELDIALOG_H

#include "parsec_mac_qt5_global.h"

#include <loginmaclabelwidget.h>

#include <QDialog>

class QLabel;

namespace ParsecQt5
{
    class PARSEC_MAC_QT5_EXPORT LoginMacLabelDialog : public QDialog
    {
    Q_OBJECT

    public:
        LoginMacLabelDialog( char *user, QWidget *parent = nullptr );
        LoginMacLabelDialog( uid_t uid, QWidget *parent = nullptr );
        virtual ~LoginMacLabelDialog() override;

        mac_lev_t level();
        mac_cat_t categories();
        char* malloc_mac_label_text();
        bool isValid();
        bool isSuitable();
        bool isVariability();

        bool editable() const;
        void setEditable( bool editable );

    protected:
        void keyPressEvent( QKeyEvent *e ) override;

    protected slots:
        void saveChoice() const;

    private:

        void initialize( uid_t uid );
        LoginMacLabelWidget *m_loginMacLabelWidget;

        QString m_userName;
        QLabel *m_label;
    };
}

#endif // LOGINMACLABELDIALOG_H
