#ifndef LOGINMACLABELWIDGET_H
#define LOGINMACLABELWIDGET_H

#include "parsec_mac_qt5_global.h"

#include <QWidget>

#include <parsec/mac.h>

#include "macfilemodel.h"

namespace Ui
{
    class LoginMacLabelWidget;
}

class QVBoxLayout;

namespace ParsecQt5
{
//---------------------------------------------------------
class PARSEC_MAC_QT5_EXPORT LoginMacLabelWidget : public QWidget
{

Q_OBJECT

public:

    LoginMacLabelWidget( uid_t /*uid*/
                       , QWidget * /*parent*/ = nullptr
                       , bool /*showRoles*/ = true );
    virtual ~LoginMacLabelWidget();
    QVBoxLayout * buttonLayout();

    void setUid( uid_t /*uid*/ );
    mac_lev_t level() const;
    mac_cat_t categories() const;
    char* malloc_mac_label_text();
    bool isValid();
    bool isSuitable();
    bool isVariability();

    bool loadLastChoice();
    bool saveChoice() const;

    QStringList getSumacArguments() const; //#4420
    QStringList getSumacCommand() const;

    bool isIntegrityLevelVisible() const;
    void setIntegrityLevelVisible( bool );
    void setMaxIntegrityLevel();

    bool editable() const;
    void setEditable(bool editable);

public slots:

    void setVisibleRoles( bool );

private:

    Ui::LoginMacLabelWidget *_ui;
    MacFileModel *_userModel;
    MacFileModel *_adminModel;
    uid_t _uid;
    bool _editable;

};

//---------------------------------------------------------
}

#endif // LOGINMACLABELWIDGET_H
