/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef MACCATEGORYCOMBOBOX_H
#define MACCATEGORYCOMBOBOX_H

#include "parsec_mac_qt5_global.h"

#include <parsec/mac.h>

#include <QComboBox>

namespace ParsecQt5
{
    class PARSEC_MAC_QT5_EXPORT MacCategoryComboBox : public QComboBox
    {
    Q_OBJECT

    public:

        MacCategoryComboBox( QWidget *parent = nullptr );
///DUMMY
///        MacCategoryComboBox( uid_t uid, QWidget *parent = nullptr );
        virtual ~MacCategoryComboBox();

        mac_cat_t value();

    signals:
        void valueChanged( mac_cat_t );

    public slots:

        void setUid( uid_t uid );
        void setMinimumValue( mac_cat_t );
        void setMaximumValue( mac_cat_t );
        void setValue( mac_cat_t );

    private slots:

        void activated( int );

    private:
        mac_cat_t m_value { 0 };
        mac_cat_t m_minimumValue { 0 };
        mac_cat_t m_maximumValue { 0 };
        uid_t m_uid { 0 };

        bool m_isUid;
        bool m_isMinimumValue;
        bool m_isMaximumValue;

    private:
        void rebuild();
    };
}

#endif // MACCATEGORYCOMBOBOX_H
