#ifndef MACCATEGORYWIDGET_H
#define MACCATEGORYWIDGET_H

#include "parsec_mac_qt5_global.h"

#include <parsec/mac.h>
#include <popupwidget.h>

#include "maccategorylistwidget.h"

#include <QWidget>

class QLabel;
class QPushButton;

namespace ParsecQt5
{
    class PARSEC_MAC_QT5_EXPORT MacCategoryWidget : public QWidget
    {
        Q_OBJECT

        public:

            MacCategoryWidget( QWidget *parent = nullptr );
            ~MacCategoryWidget();

            bool hasAvailableCategories();
            mac_cat_t value();

        signals:
            void valueChanged( mac_cat_t );

        public slots:
            void setUid( uid_t );
            void setMinimumValue( mac_cat_t );
            void setMaximumValue( mac_cat_t );
            void setValue( mac_cat_t );

        private slots:
            void callCategoriesDialog();
            void popupCategoriesWidget();
            void categoriesUpdated( mac_cat_t );

        private:
            QLabel *m_label;
            QPushButton *m_button;
            MacCategoryListWidget *m_categoryListWidget;
            PopupWidget *m_categoryPopupWidget;
    };
}

#endif // MACCATEGORYWIDGET_H
