#ifndef MACFILEITEM_H
#define MACFILEITEM_H

#include "hierarchyitem.h"

#include <sys/types.h>
#include <QString>

namespace ParsecQt5
{

class PARSEC_MAC_QT5_EXPORT MacFileItem : public HierarchyItem
{
public:

    enum VarName { Name
                 , Checked
                 , Id
                 , VarNameSize };

    static HierarchyItem * createItem( HierarchyItem * /*parent*/ = nullptr );

    MacFileItem( HierarchyItem * /*parent*/ = nullptr );
    virtual ~MacFileItem();

    virtual bool load( const QString & /*path*/
                     , const QString & /*name*/ );

    QString fileName;
    ino_t fileId;
    bool fileChecked;

protected:

    static ino_t getId( const char * /*filePath*/ );

};

}

#endif
