#ifndef MACFILEMODEL_H
#define MACFILEMODEL_H

#include "hierarchymodel.h"
#include "macfileitem.h"

#include <QObject>
#include <QModelIndex>

#include <QString>
#include <QVariant>

#include <QList>
#include <sys/stat.h>

namespace ParsecQt5
{

class PARSEC_MAC_QT5_EXPORT MacFileModel : public HierarchyModel
{

Q_OBJECT

public:

    MacFileModel( const QString & /*path*/
             , QObject * /*parent*/ = nullptr
             , HierarchyItem *( * /*createItemFunction*/ )( HierarchyItem * ) = ParsecQt5::MacFileItem::createItem );

    virtual ~MacFileModel() override;

    int columnCount( const QModelIndex & /*index*/ = QModelIndex() ) const override;
    QVariant data( const QModelIndex & /*index*/
                 , int /*role*/ = Qt::DisplayRole ) const override;
    Qt::ItemFlags flags( const QModelIndex & /*index*/ ) const override;
    QVariant headerData(int /*section*/
                       , Qt::Orientation /*orientation*/
                       , int /*role*/ = Qt::DisplayRole) const override;
    bool setData( const QModelIndex & /*index*/
                , const QVariant & /*value*/
                , int /*role*/ = Qt::EditRole ) override;

    const QString & getRootPath() const;

    QList< ino_t > checkedIds() const;

private:

    QString rootPath;
};

}

#endif
