/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef MACLEVELCOMBOBOX_H
#define MACLEVELCOMBOBOX_H

#include "parsec_mac_qt5_global.h"

#include <parsec/mac.h>

#include <QComboBox>

namespace ParsecQt5
{
    class PARSEC_MAC_QT5_EXPORT MacLevelComboBox : public QComboBox {
    Q_OBJECT

    public:

        MacLevelComboBox( QWidget *parent = nullptr );
        MacLevelComboBox( uid_t uid, QWidget *parent = nullptr );
        virtual ~MacLevelComboBox();

        bool isSuitable();
        mac_lev_t minimumValue();
        mac_lev_t maximumValue();
        mac_lev_t value();

        bool rebuild();
        bool isRebuilt() const;

    signals:
        void valueChanged( mac_lev_t );

    public slots:
        bool setUid( uid_t uid );
        bool setMinimumValue( mac_lev_t );
        bool setMaximumValue( mac_lev_t );
        bool setValue( mac_lev_t, bool force = false );

    private slots:

        void activated( int );

    private:
        bool setValuePrivate( mac_lev_t lev, bool force = false );

        mac_lev_t m_minimumValue { 0 };
        mac_lev_t m_maximumValue { 0 };
        uid_t m_uid { 0 };

        bool m_isUid;
        bool m_isMinimumValue;
        bool m_isMaximumValue;
        bool _isRebuilt { false };

    };
}

#endif // MACLEVELCOMBOBOX_H
