#ifndef SPECIALATTRIBUTESLISTMODEL_H
#define SPECIALATTRIBUTESLISTMODEL_H

#include "parsec_mac_qt5_global.h"

#include <QAbstractListModel>
#include <QVector>

namespace ParsecQt5
{
class PARSEC_MAC_QT5_EXPORT SpecialAttributesListModel : public QAbstractListModel
{
    Q_OBJECT

public:

    enum Attributes{ CCNR
                   , CCNRI
                   , EHOLE
                   , WHOLE
                   , OTHER
                   , AttributesCount };

    SpecialAttributesListModel( QObject */*parent*/ = nullptr);
    QVariant data( const QModelIndex & /*index*/
                 , int /*role*/ = Qt::DisplayRole) const override;

    Qt::ItemFlags flags(const QModelIndex & /*index*/ ) const override;

    int rowCount(const QModelIndex & /*parent*/ = QModelIndex()) const override;
    bool setData(const QModelIndex & /*index*/, const QVariant & /*value*/, int /*role*/ = Qt::EditRole) override;

    void setForContainer(bool on);
    bool isForContainer() const;

    Qt::CheckState checkState( Attributes /*attribute*/) const;
    bool setCheckState( Attributes /*attribute*/, Qt::CheckState /*state*/);
    bool setEnabled( Attributes /*attribute*/, bool /*state*/);

    int otherAttribute() const;
    bool setOtherAttribute( int );

signals:
    void attributeChanged(Attributes);

protected:
    int attributeForRow(int row) const;
    int rowForAttribute(int attr) const;

    QVector< bool > _checkedAttributes;
    QVector< bool > _enabledAttributes;

    int _otherAttribute;
    bool _forContainer;

};

}

#endif // SPECIALATTRIBUTESLISTMODEL_H
